<?php
/*
Plugin Name: افزونه ارسال لینک دانلود به ایمیل Subscribe & Download
Plugin URI: https://wpnovin.com/subscribe-download/
Description: افزونه ارسال لینک دانلود به ایمیل یک افزونه کاربردی برای آن دسته از عزیزانی است که میخواهند اقدام به جمع آوری ایمیل بکنند. افزونه وردپرس Subscribe & Download  اینکار را براحتی برای شما انجام خواهد داد چون کسانی که میخواهند لینک دانلود مطالب شما را داشته باشند باید اطلاعات تماس خود را وارد کنند تا لینک دانلود برای آن ها ارسال شود.
Version: 3.28
Author: نوین وردپرس
Author URI: wpnovin.com
*/
define('SUBSCRIBEDOWNLOAD_RECORDS_PER_PAGE', '20');
define('SUBSCRIBEDOWNLOAD_VERSION', 3.28);
define('SUBSCRIBEDOWNLOAD_AWEBER_APPID', '577391a0');
register_activation_hook(__FILE__, array("subscribedownload_class", "install"));

class subscribedownload_class {
	var $options;
	
	function __construct() {
		if (function_exists('load_plugin_textdomain')) {
			load_plugin_textdomain('subscribedownload', false, dirname(plugin_basename(__FILE__)).'/languages/');
		}
		
		$this->options = array (
			"version" => SUBSCRIBEDOWNLOAD_VERSION,
			"intro" => __('Complete your name and email to receive free download.', 'subscribedownload'),
			"from_name" => get_bloginfo("name"),
			"from_email" => "noreply@".str_replace("www.", "", $_SERVER["SERVER_NAME"]),
			"success_email_subject" => __('Item download details', 'subscribedownload'),
			"success_email_body" => __('Dear {name},', 'subscribedownload').PHP_EOL.PHP_EOL.__('Thank you for subscription. Click the link below to download the item:', 'subscribedownload').PHP_EOL.'{download_link}'.PHP_EOL.PHP_EOL.__('Thanks,', 'subscribedownload').PHP_EOL.get_bloginfo("name"),
			"button_label" => __('Get Download Link', 'subscribedownload'),
			"placeholder_email" => __('Enter your e-mail...', 'subscribedownload'),
			"placeholder_name" => __('Enter your name...', 'subscribedownload'),
			'box_color' => '#F8F8F8',
			'box_border_color' => '#CCCCCC',
			'box_font_color' => '#333333',
			'box_font_size' => 13,
			'button_color' => '#0147A3',
			'button_font_color' => '#FFFFFF',
			'button_font_size' => 14,
			'input_font_color' => '#333333',
			'input_font_size' => 13,
			'input_border_color' => '#444444',
			'input_background_color' => '#FFFFFF',
			'input_background_opacity' => 0.7,
			"csv_separator" => ";",
			"ga_tracking" => "off",
			'email_validation' => "off",
			"disable_name" => "off",
			"link_lifetime" => "2",
			"mail_enable" => "off",
			"mail_email" => "",
			"mail_subject" => __('New Subscriber', 'subscribedownload'),
			"mail_message" => __('Dear Administrator,', 'subscribedownload').PHP_EOL.PHP_EOL.__('This is notification about new subscriber.', 'subscribedownload').PHP_EOL.PHP_EOL.'<strong>Name:</strong> {name}'.PHP_EOL.'<strong>E-mail:</strong> {e-mail}'.PHP_EOL.'<strong>IP:</strong> {ip}'.PHP_EOL.'<strong>Source:</strong> {source}'.PHP_EOL.'<strong>Download link:</strong> {download_link}'.PHP_EOL.PHP_EOL.__('Thanks,', 'subscribedownload').PHP_EOL.get_bloginfo("name"),
			"mail_from" => "off",
			"mailchimp_enable" => "off",
			"mailchimp_api_key" => "",
			"mailchimp_list_id" => "",
			"mailchimp_double" => "off",
			"mailchimp_welcome" => "off",
			"icontact_enable" => "off",
			"icontact_appid" => "",
			"icontact_apiusername" => "",
			"icontact_apipassword" => "",
			"icontact_listid" => "",
			'campaignmonitor_enable' => "off",
			'campaignmonitor_api_key' => '',
			'campaignmonitor_list_id' => '',
			'getresponse_enable' => "off",
			'getresponse_api_key' => '',
			'getresponse_campaign_id' => '',
			'aweber_enable' => "off",
			'aweber_consumer_key' => "",
			'aweber_consumer_secret' => "",
			'aweber_access_key' => "",
			'aweber_access_secret' => "",
			'aweber_listid' => "",
			'madmimi_enable' => 'off',
			'madmimi_login' => '',
			'madmimi_api_key' => '',
			'madmimi_list_id' => '',
			'mymail_enable' => "off",
			'mymail_listid' => "",
			'mymail_double' => "off",
			"terms" => ""
		);

		if (defined('WP_ALLOW_MULTISITE')) $this->install();
		$this->get_options();
		
		if (is_admin()) {
			if ($this->check_options() !== true) add_action('admin_notices', array(&$this, 'admin_warning'));
			add_action('admin_enqueue_scripts', array(&$this, 'admin_enqueue_scripts'));
			add_action('admin_menu', array(&$this, 'admin_menu'));
			add_action('init', array(&$this, 'admin_request_handler'));
			add_action('wp_ajax_subscribedownload_submit', array(&$this, "subscribedownload_submit"));
			add_action('wp_ajax_nopriv_subscribedownload_submit', array(&$this, "subscribedownload_submit"));
			add_action('wp_ajax_subscribedownload_aweber_connect', array(&$this, "aweber_connect"));
			add_action('wp_ajax_subscribedownload_aweber_disconnect', array(&$this, "aweber_disconnect"));
		} else {
			add_action('init', array(&$this, 'front_init'));
			add_shortcode('sdfile', array(&$this, "shortcode_handler"));
		}
	}

	function admin_enqueue_scripts() {
		wp_enqueue_script('jquery');
		if (isset($_GET['page']) && $_GET['page'] == 'subscribedownload') {
			wp_enqueue_script("thickbox");
			wp_enqueue_style("thickbox");
			wp_enqueue_script('subscribedownload', plugins_url('/js/admin.js', __FILE__), array(), SUBSCRIBEDOWNLOAD_VERSION);
			wp_enqueue_style('wp-color-picker');
			wp_enqueue_script('wp-color-picker');
		}
		wp_enqueue_style('subscribedownload', plugins_url('/css/admin.css', __FILE__), array(), SUBSCRIBEDOWNLOAD_VERSION);
	}

	function front_init() {
		global $wpdb;
		if (isset($_GET['sad-key'])) {
			$download_key = $_GET["sad-key"];
			$download_key = preg_replace('/[^a-zA-Z0-9]/', '', $download_key);
			$sql = "SELECT * FROM ".$wpdb->prefix."sad_users WHERE secret_key = '".$download_key."' AND deleted = '0'";
			$user_details = $wpdb->get_row($sql, ARRAY_A);
			if (intval($user_details["id"]) == 0) die(__('Invalid download link', 'subscribedownload'));
			if ($user_details["registered"]+24*3600*intval($this->options['link_lifetime']) < time()) die(__('Download link was expired', 'subscribedownload'));
			header('Location: '.$user_details["url"]);
			exit;
		}
		add_action('wp_enqueue_scripts', array(&$this, 'front_enqueue_scripts'));
		add_action('wp_head', array(&$this, 'front_header'));
	}

	function front_enqueue_scripts() {
		wp_enqueue_script('jquery');
		wp_enqueue_script('subscribedownload', plugins_url('/js/script.js', __FILE__), array(), SUBSCRIBEDOWNLOAD_VERSION);
		wp_enqueue_style('subscribedownload', plugins_url('/css/style.css', __FILE__), array(), SUBSCRIBEDOWNLOAD_VERSION);
	}

	static function install () {
		global $wpdb;

		$table_name = $wpdb->prefix."sad_users";
		if($wpdb->get_var("SHOW TABLES LIKE '".$table_name."'") != $table_name) {
			$sql = "CREATE TABLE ".$table_name." (
				id int(11) NULL auto_increment,
				name varchar(255) collate utf8_unicode_ci NULL,
				email varchar(255) collate utf8_unicode_ci NULL,
				secret_key varchar(64) collate latin1_general_cs NULL,
				url varchar(255) collate utf8_unicode_ci NULL,
				registered int(11) NULL,
				deleted int(11) NOT NULL default '0',
				UNIQUE KEY  id (id)
			);";
			require_once(ABSPATH.'wp-admin/includes/upgrade.php');
			dbDelta($sql);
		}
		if ($wpdb->get_var("SHOW COLUMNS FROM ".$wpdb->prefix."sad_users LIKE 'secret_key'") != 'secret_key') {
			$sql = "ALTER TABLE ".$wpdb->prefix."sad_users ADD secret_key varchar(64) CHARACTER SET latin1 COLLATE latin1_general_cs NULL";
			$wpdb->query($sql);
		}
	}
	
	function get_options() {
		$exists = get_option('subscribedownload_version');
		if ($exists) {
			foreach ($this->options as $key => $value) {
				$this->options[$key] = get_option('subscribedownload_'.$key, $this->options[$key]);
			}
		}
	}

	function update_options() {
		//if (current_user_can('manage_options')) {
			foreach ($this->options as $key => $value) {
				update_option('subscribedownload_'.$key, $value);
			}
		//}
	}

	function populate_options() {
		foreach ($this->options as $key => $value) {
			if (isset($_POST['subscribedownload_'.$key])) {
				$this->options[$key] = stripslashes($_POST['subscribedownload_'.$key]);
			}
		}
	}

	function check_options() {
		$errors = array();
		if (!preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,9})$/i", $this->options['from_email']) || strlen($this->options['from_email']) == 0) $errors[] = __('Sender e-mail must be valid e-mail address', 'subscribedownload');
		if (strlen($this->options['from_name']) < 3) $errors[] = __('Sender name is too short', 'subscribedownload');
		if (strlen($this->options['success_email_subject']) < 3) $errors[] = __('Thanksgiving e-mail subject must contain at least 3 characters', 'subscribedownload');
		else if (strlen($this->options['success_email_subject']) > 64) $errors[] = __('Thanksgiving e-mail subject must contain maximum 64 characters', 'subscribedownload');
		if (strlen($this->options['success_email_body']) < 3) $errors[] = __('Thanksgiving e-mail body must contain at least 3 characters', 'subscribedownload');
		
		if (strlen($this->options['box_color']) > 0 && $this->get_rgb($this->options['box_color']) === false) $errors[] = __('Box background color must be a valid value.', 'subscribedownload');
		if (strlen($this->options['box_border_color']) > 0 && $this->get_rgb($this->options['box_border_color']) === false) $errors[] = __('Box border color must be a valid value.', 'subscribedownload');
		if (strlen($this->options['box_font_color']) > 0 && $this->get_rgb($this->options['box_font_color']) === false) $errors[] = __('Font color must be a valid value.', 'subscribedownload');
		if (strlen($this->options['input_border_color']) > 0 && $this->get_rgb($this->options['input_border_color']) === false) $errors[] = __('Input field border color must be a valid value.', 'subscribedownload');
		if (strlen($this->options['input_background_color']) > 0 && $this->get_rgb($this->options['input_background_color']) === false) $errors[] = __('Input field background color must be a valid value.', 'subscribedownload');
		if (floatval($this->options['input_background_opacity']) < 0 || floatval($this->options['input_background_opacity']) > 1) $errors[] = __('Input field background opacity must be in a range [0...1].', 'subscribedownload');
		if (strlen($this->options['input_font_color']) == 0 || $this->get_rgb($this->options['input_font_color']) === false) $errors[] = __('I font color must be a valid value.', 'subscribedownload');
		if (strlen($this->options['button_color']) == 0 || $this->get_rgb($this->options['button_color']) === false) $errors[] = __('Button color must be a valid value.', 'subscribedownload');
		if (strlen($this->options['button_font_color']) == 0 || $this->get_rgb($this->options['button_font_color']) === false) $errors[] = __('Button font color must be a valid value.', 'subscribedownload');
		if (strlen($this->options['box_font_size']) > 0 && $this->options['box_font_size'] != preg_replace('/[^0-9]/', '', $this->options['box_font_size']) && ($this->options['box_font_size'] > 72 || $this->options['box_font_size'] < 10)) $errors[] = __('Font size must be in a range [10...72].', 'subscribedownload');
		if (strlen($this->options['input_font_size']) > 0 && $this->options['input_font_size'] != preg_replace('/[^0-9]/', '', $this->options['input_font_size']) && ($this->options['input_font_size'] > 72 || $this->options['input_font_size'] < 10)) $errors[] = __('Input field font size must be in a range [10...72].', 'subscribedownload');
		if (strlen($this->options['button_font_size']) > 0 && $this->options['button_font_size'] != preg_replace('/[^0-9]/', '', $this->options['button_font_size']) && ($this->options['button_font_size'] > 72 || $this->options['button_font_size'] < 10)) $errors[] = __('Button font size must be in a range [10...72].', 'subscribedownload');

		if ($this->options['mail_enable'] == 'on') {
			$emails = explode(',', $this->options['mail_email']);
			$emails_found = false;
			$emails_invalid = false;
			foreach ($emails as $email) {
				$email = trim($email);
				if (!empty($email)) {
					if (!preg_match("/^[_a-z0-9-+]+(\.[_a-z0-9-+]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,9})$/i", $email)) $emails_invalid = true;
					else $emails_found = true;
				}
			}
			if (!$emails_found) $errors[] = __('Admin e-mail must be valid e-mail address.', 'subscribedownload');
			else if ($emails_invalid) $errors[] = __('Admin e-mail must be valid e-mail address.', 'subscribedownload');
			if (strlen($this->options['mail_subject']) < 3) $errors[] = __('Notification subject must contain at least 3 characters', 'subscribedownload');
			else if (strlen($this->options['mail_subject']) > 64) $errors[] = __('Notification subject must contain maximum 64 characters', 'subscribedownload');
			if (strlen($this->options['mail_message']) < 3) $errors[] = __('Notification body must contain at least 3 characters', 'subscribedownload');
		}
		
		if ($this->options['mailchimp_enable'] == 'on') {
			if (empty($this->options['mailchimp_api_key']) || strpos($this->options['mailchimp_api_key'], '-') === false) $errors[] = __('Invalid MailChimp API Key', 'subscribedownload');
			if (empty($this->options['mailchimp_list_id'])) $errors[] = __('Invalid MailChimp List ID', 'subscribedownload');
		}
		if ($this->options['icontact_enable'] == 'on') {
			if (empty($this->options['icontact_appid'])) $errors[] = __('Invalid iContact AppID', 'subscribedownload');
			if (empty($this->options['icontact_apiusername'])) $errors[] = __('Invalid iContact API Username', 'subscribedownload');
			if (empty($this->options['icontact_apipassword'])) $errors[] = __('Invalid iContact API Password', 'subscribedownload');
			if (empty($this->options['icontact_listid'])) $errors[] = __('Invalid iContact List ID', 'subscribedownload');
		}
		if ($this->options['campaignmonitor_enable'] == 'on') {
			if (empty($this->options['campaignmonitor_api_key'])) $errors[] = __('Invalid Campaign Monitor API Key', 'subscribedownload');
			if (empty($this->options['campaignmonitor_list_id'])) $errors[] = __('Invalid Campaign Monitor List ID', 'subscribedownload');
		}
		if ($this->options['getresponse_enable'] == 'on') {
			if (empty($this->options['getresponse_api_key'])) $errors[] = __('Invalid GetResponse API Key', 'subscribedownload');
			if (empty($this->options['getresponse_campaign_id'])) $errors[] = __('Invalid GetResponse Campaign ID', 'subscribedownload');
		}
		if ($this->options['aweber_enable'] == 'on') {
			if (empty($this->options['aweber_access_secret'])) $errors[] = __('Invalid AWeber Connection', 'subscribedownload');
			else if (empty($this->options['aweber_listid'])) $errors[] = __('Invalid AWeber List ID', 'subscribedownload');
		}
		if ($this->options['madmimi_enable'] == 'on') {
			if (empty($this->options['madmimi_login'])) $errors[] = __('Invalid Mad Mimi login', 'subscribedownload');
			if (empty($this->options['madmimi_api_key'])) $errors[] = __('Invalid Mad Mimi API key', 'subscribedownload');
			if (empty($this->options['madmimi_list_id'])) $errors[] = __('Invalid Mad Mimi list ID', 'subscribedownload');
		}
		if ($this->options['mymail_enable'] == 'on') {
			if (empty($this->options['mymail_listid'])) $errors[] = __('Invalid MyMail List ID', 'subscribedownload');
		}
		if (strlen($this->options['placeholder_name']) < 3) $errors[] = __('"Name" field placeholder is too short', 'subscribedownload');
		if (strlen($this->options['placeholder_email']) < 3) $errors[] = __('"E-mail" field placeholder is too short', 'subscribedownload');
		if (strlen($this->options['button_label']) < 2) $errors[] = __('"Subscribe" button label is too short', 'subscribedownload');
		if (empty($errors)) return true;
		return $errors;
	}

	function admin_menu() {
		add_menu_page(
			__('Subscribe & Download', 'subscribedownload')
			, __('Subscribe & Download', 'subscribedownload')
			, 'manage_options'
			, 'subscribedownload'
			, array(&$this, 'admin_settings')
		);
		add_submenu_page(
			'subscribedownload'
			, __('Settings', 'subscribedownload')
			, __('Settings', 'subscribedownload')
			, 'manage_options'
			, 'subscribedownload'
			, array(&$this, 'admin_settings')
		);
		add_submenu_page(
			'subscribedownload'
			, __('Subscribers', 'subscribedownload')
			, __('Subscribers', 'subscribedownload')
			, 'manage_options'
			, 'subscribedownload-users'
			, array(&$this, 'admin_users')
		);
	}

	function admin_settings() {
		global $wpdb;
		$message = "";
		$errors = $this->check_options();
		if (is_array($errors)) echo "<div class='error'><p>".__('The following error(s) exists:', 'subscribedownload')."<br />- ".implode("<br />- ", $errors)."</p></div>";
		if (isset($_GET["updated"]) && $_GET["updated"] == "true") {
			$message = '<div class="updated"><p>'.__('Plugin settings successfully <strong>updated</strong>.', 'subscribedownload').'</p></div>';
		}
		echo '
		<div class="wrap admin_subscribedownload_wrap">
			<div id="icon-options-general" class="icon32"><br /></div><h2>'.__('Subscribe & Download - Settings', 'subscribedownload').'</h2><br /> 
			'.$message.'
			<form enctype="multipart/form-data" method="post" style="margin: 0px" action="'.admin_url('admin.php').'">
			<div class="postbox-container" style="width: 100%;">
				<div class="metabox-holder">
					<div class="meta-box-sortables ui-sortable">
						<div class="postbox subscribedownload_postbox">
							<!--<div class="handlediv" title="Click to toggle"><br></div>-->
							<h3 class="hndle" style="cursor: default;"><span>'.__('General Settings', 'subscribedownload').'</span></h3>
							<div class="inside">
								<table class="subscribedownload_useroptions">
									<tr>
										<th>'.__('Sender name', 'subscribedownload').':</th>
										<td><input type="text" id="subscribedownload_from_name" name="subscribedownload_from_name" value="'.htmlspecialchars($this->options['from_name'], ENT_QUOTES).'" class="widefat"><br /><em>'.__('Please enter sender name. All messages to buyers are sent using this name as "FROM:" header value.', 'subscribedownload').'</em></td>
									</tr>
									<tr>
										<th>'.__('Sender e-mail', 'subscribedownload').':</th>
										<td><input type="text" id="subscribedownload_from_email" name="subscribedownload_from_email" value="'.htmlspecialchars($this->options['from_email'], ENT_QUOTES).'" class="widefat"><br /><em>'.__('Please enter sender e-mail. All messages to buyers are sent using this e-mail as "FROM:" header value.', 'subscribedownload').'</em></td>
									</tr>
									<tr>
										<th>'.__('Thanksgiving e-mail subject', 'subscribedownload').':</th>
										<td><input type="text" id="subscribedownload_success_email_subject" name="subscribedownload_success_email_subject" value="'.htmlspecialchars($this->options['success_email_subject'], ENT_QUOTES).'" class="widefat"><br /><em>'.__('In case of successful subscription, your visitors receive e-mail message which contains download link. This is subject field of the message.', 'subscribedownload').'</em></td>
									</tr>
									<tr>
										<th>'.__('Thanksgiving e-mail body', 'subscribedownload').':</th>
										<td><textarea id="subscribedownload_success_email_body" name="subscribedownload_success_email_body" class="widefat" style="height: 120px;">'.htmlspecialchars($this->options['success_email_body'], ENT_QUOTES).'</textarea><br /><em>'.__('This e-mail message is sent to your visitor in case of successful subscription. You can use the following keywords: {download_link}, {name}, {e-mail}.', 'subscribedownload').'</em></td>
									</tr>
									<tr>
										<th>'.__('Intro:', 'subscribedownload').'</th>
										<td>';
		if (function_exists('wp_editor')) {
			wp_editor($this->options['intro'], "subscribedownload_intro", array('wpautop' => false));
		} else {
			echo '
											<textarea class="widefat" id="subscribedownload_intro" name="subscribedownload_intro" style="height: 120px;">'.htmlspecialchars($this->options['intro'], ENT_QUOTES).'</textarea><br />';
		}
		echo '									
											<em>'.__('Please enter content of opt-in box. HTML allowed. Opt-in form is inserted below this content. You can overload this content for each shortcode by inserting "title" attribute like: [sdfile url="http://url-goes-here" title="Content goes here"]', 'subscribedownload').'</em>
										</td>
									</tr> 
									<tr>
										<th>'.__('Terms & Conditions', 'subscribedownload').':</th>
										<td><textarea id="subscribedownload_terms" name="subscribedownload_terms" class="widefat" style="height: 120px;">'.htmlspecialchars($this->options['terms'], ENT_QUOTES).'</textarea><br /><em>'.__('Your customers must be agree with Terms & Conditions before donating. Leave this field blank if you do not need Terms & Conditions box to be shown.', 'subscribedownload').'</em></td>
									</tr>
									<tr>
										<th>'.__('CSV column separator', 'subscribedownload').':</th>
										<td>
											<select id="subscribedownload_csv_separator" name="subscribedownload_csv_separator">
												<option value=";"'.($this->options['csv_separator'] == ';' ? ' selected="selected"' : '').'>'.__('Semicolon - ";"', 'subscribedownload').'</option>
												<option value=","'.($this->options['csv_separator'] == ',' ? ' selected="selected"' : '').'>'.__('Comma - ","', 'subscribedownload').'</option>
												<option value="tab"'.($this->options['csv_separator'] == 'tab' ? ' selected="selected"' : '').'>'.__('Tab', 'subscribedownload').'</option>
											</select>
											<br /><em>'.__('Please select CSV column separator.', 'subscribedownload').'</em></td>
									</tr>
									<tr>
										<th>'.__('"Name" field placeholder', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_placeholder_name" name="subscribedownload_placeholder_name" value="'.htmlspecialchars($this->options['placeholder_name'], ENT_QUOTES).'" class="widefat">
											<br /><em>'.__('Enter the placeholder for "Name" input field.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Disable "name" field', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_disable_name" name="subscribedownload_disable_name" '.($this->options['disable_name'] == "on" ? 'checked="checked"' : '').'"> '.__('Disable "Name" field in opt-in form', 'subscribedownload').'
											<br /><em>'.__('Please tick checkbox if you want to disable "Name" field in opt-in form.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('"E-mail" field placeholder', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_placeholder_email" name="subscribedownload_placeholder_email" value="'.htmlspecialchars($this->options['placeholder_email'], ENT_QUOTES).'" class="widefat">
											<br /><em>'.__('Enter the placeholder for "E-mail" input field.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Extended e-mail validation', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_email_validation" name="subscribedownload_email_validation" '.($this->options['email_validation'] == "on" ? 'checked="checked"' : '').'"> '.__('Enable extended e-mail address validation', 'subscribedownload').'
											<br /><em>'.__('If you turn this option on, the plugin will check MX records according to the host provided within the email address. PHP 5 >= 5.3 required!', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('"Subscribe" button label', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_button_label" name="subscribedownload_button_label" value="'.htmlspecialchars($this->options['button_label'], ENT_QUOTES).'" class="widefat">
											<br /><em>'.__('Enter the label for "Subscribe" button.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Temporary link lifetime', 'subscribedownload').':</th>
										<td style="vertical-align: middle;">
											<input type="text" id="subscribedownload_link_lifetime" name="subscribedownload_link_lifetime" value="'.htmlspecialchars($this->options['link_lifetime'], ENT_QUOTES).'" style="width: 60px; text-align: right;"> days
											<br /><em>'.__('Original download links will be replaced by temporary download links. Please enter period of download link validity.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Google Analytics tracking', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_ga_tracking" name="subscribedownload_ga_tracking" '.($this->options['ga_tracking'] == "on" ? 'checked="checked"' : '').'"> '.__('Enable Google Analytics tracking', 'subscribedownload').'
											<br /><em>'.__('Send subscribtion event to Google Analytics. Google Analytics must be installed on your website.', 'subscribedownload').'</em>
										</td>
									</tr>
								</table>
								<div class="alignright">
								<input type="hidden" name="action" value="subscribedownload-update-options" />
								<input type="hidden" name="subscribedownload_version" value="'.SUBSCRIBEDOWNLOAD_VERSION.'" />
								<input type="submit" class="subscribedownload_button button-primary" name="submit" value="'.__('Update Settings', 'subscribedownload').'">
								</div>
							</div>
						</div>
						<div class="postbox subscribedownload_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('Design Settings', 'subscribedownload').'</span></h3>
							<div class="inside">
								<table class="subscribedownload_useroptions">
									<tr>
										<th>'.__('Box background color', 'subscribedownload').':</th>
										<td>
											<input type="text" class="subscribedownload-color ic_input_number" name="subscribedownload_box_color" value="'.esc_attr($this->options['box_color']).'" placeholder=""> 
											<br /><em>'.__('Set main box background color. Leave empty for transparent background.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Box border color', 'subscribedownload').':</th>
										<td>
											<input type="text" class="subscribedownload-color ic_input_number" name="subscribedownload_box_border_color" value="'.esc_attr($this->options['box_border_color']).'" placeholder=""> 
											<br /><em>'.__('Set main box border color. Leave empty for transparent border.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Font color', 'subscribedownload').':</th>
										<td>
											<input type="text" class="subscribedownload-color ic_input_number" name="subscribedownload_box_font_color" value="'.esc_attr($this->options['box_font_color']).'" placeholder="">
											<br /><em>'.__('Set font color. Leave empty for default font color.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Font size', 'subscribedownload').':</th>
										<td style="vertical-align: middle;">
											<input type="text" class="ic_input_number" name="subscribedownload_box_font_size" value="'.esc_attr($this->options['box_font_size']).'" placeholder="pixels"> '.__('pixels', 'subscribedownload').'
											<br /><em>'.__('Set font size (pixels).', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Input field border color', 'subscribedownload').':</th>
										<td>
											<input type="text" class="subscribedownload-color ic_input_number" name="subscribedownload_input_border_color" value="'.esc_attr($this->options['input_border_color']).'" placeholder="">
											<br /><em>'.__('Set border color of "Name" and "E-mail" input fields.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Input field background color', 'subscribedownload').':</th>
										<td>
											<input type="text" class="subscribedownload-color ic_input_number" name="subscribedownload_input_background_color" value="'.esc_attr($this->options['input_background_color']).'" placeholder="">
											<br /><em>'.__('Set background color of "Name" and "E-mail" input fields.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Input field background opacity', 'subscribedownload').':</th>
										<td>
											<input type="text" class="ic_input_number" name="subscribedownload_input_background_opacity" value="'.esc_attr($this->options['input_background_opacity']).'" placeholder="[0...1]">
											<br /><em>'.__('Set background opacity of "Name" and "E-mail" input fields. The value must be in a range [0...1].', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Input field font color', 'subscribedownload').':</th>
										<td>
											<input type="text" class="subscribedownload-color ic_input_number" name="subscribedownload_input_font_color" value="'.esc_attr($this->options['input_font_color']).'" placeholder="">
											<br /><em>'.__('Set font color of "Name" and "E-mail" input fields.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Input field font size', 'subscribedownload').':</th>
										<td style="vertical-align: middle;">
											<input type="text" class="ic_input_number" name="subscribedownload_input_font_size" value="'.esc_attr($this->options['input_font_size']).'" placeholder="pixels"> '.__('pixels', 'subscribedownload').'
											<br /><em>'.__('Set font size (pixels) of "Name" and "E-mail" input fields.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Button color', 'subscribedownload').':</th>
										<td>
											<input type="text" class="subscribedownload-color ic_input_number" name="subscribedownload_button_color" value="'.esc_attr($this->options['button_color']).'" placeholder=""> 
											<br /><em>'.__('Set button color.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Button font color', 'subscribedownload').':</th>
										<td>
											<input type="text" class="subscribedownload-color ic_input_number" name="subscribedownload_button_font_color" value="'.esc_attr($this->options['button_font_color']).'" placeholder="">
											<br /><em>'.__('Set button font color.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Button font size', 'subscribedownload').':</th>
										<td style="vertical-align: middle;">
											<input type="text" class="ic_input_number" name="subscribedownload_button_font_size" value="'.esc_attr($this->options['button_font_size']).'" placeholder="pixels"> '.__('pixels', 'subscribedownload').'
											<br /><em>'.__('Set font size (pixels) of the button.', 'subscribedownload').'</em>
										</td>
									</tr>
								</table>
								<div class="alignright">
								<input type="submit" class="subscribedownload_button button-primary" name="submit" value="'.__('Update Settings', 'subscribedownload').'">
								</div>
							</div>
						</div>
						<div class="postbox subscribedownload_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('Admin Notification Settings', 'subscribedownload').'</span></h3>
							<div class="inside">
								<table class="subscribedownload_useroptions">
									<tr>
										<th>'.__('Enable mailing', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_mail_enable" name="subscribedownload_mail_enable" '.($this->options['mail_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Send details to admin', 'subscribedownload').'
											<br /><em>'.__('Please tick checkbox if you want to receive submitted contact details by e-mail.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Admin e-mail address', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_mail_email" name="subscribedownload_mail_email" value="'.esc_html($this->options['mail_email']).'" class="widefat">
											<br /><em>'.__('Enter your e-mail address. Submitted contact details will be sent to this e-mail address. You can set several comma-separated e-mails.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Subject', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_mail_subject" name="subscribedownload_mail_subject" value="'.esc_html($this->options['mail_subject']).'" class="widefat">
											<br /><em>'.__('In case of successful subscription, administrator may receive notification message. This is subject field of the message.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Message', 'subscribedownload').':</th>
										<td>
											<textarea id="subscribedownload_mail_message" name="subscribedownload_mail_message" class="widefat" style="height: 120px;">'.esc_html($this->options['mail_message']).'</textarea>
											<br /><em>'.__('This notification is sent to administrator in case of successful subscription. You can use the keywords: {e-mail}, {name}, {ip}, {source} and {download_link}.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('"FROM" header', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_mail_from" name="subscribedownload_mail_from" '.($this->options['mail_from'] == "on" ? 'checked="checked"' : '').'"> '.__("Put user's e-mail into FROM header (not recommended)", 'subscribedownload').'
											<br /><em>'.__('Please remember, many hosting providers do not allow to send e-mails with 3rd party FROM header.', 'subscribedownload').'</em>
										</td>
									</tr>
								</table>
								<div class="alignright">
								<input type="submit" class="subscribedownload_button button-primary" name="submit" value="'.__('Update Settings', 'subscribedownload').'">
								</div>
							</div>
						</div>
						<div class="postbox subscribedownload_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('MailChimp Settings', 'subscribedownload').'</span></h3>
							<div class="inside">
								<table class="subscribedownload_useroptions">
									<tr>
										<th>'.__('Enable MailChimp', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_mailchimp_enable" name="subscribedownload_mailchimp_enable" '.($this->options['mailchimp_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to MailChimp', 'subscribedownload').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to MailChimp.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('MailChimp API Key:', 'subscribedownload').'</th>
										<td>
											<input type="text" id="subscribedownload_mailchimp_api_key" name="subscribedownload_mailchimp_api_key" value="'.htmlspecialchars($this->options['mailchimp_api_key'], ENT_QUOTES).'" class="widefat">
											<br /><em>'.__('Enter your MailChimp API Key. You can get it <a href="https://admin.mailchimp.com/account/api-key-popup" target="_blank">here</a>.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('List ID:', 'subscribedownload').'</th>
										<td>
											<input type="text" id="subscribedownload_mailchimp_list_id" name="subscribedownload_mailchimp_list_id" value="'.htmlspecialchars($this->options['mailchimp_list_id'], ENT_QUOTES).'" class="widefat">
											<br /><em>'.__('Enter your List ID. You can get it <a href="https://admin.mailchimp.com/lists/" target="_blank">here</a> (click <strong>Settings</strong>).', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Double opt-in', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_mailchimp_double" name="subscribedownload_mailchimp_double" '.($this->options['mailchimp_double'] == "on" ? 'checked="checked"' : '').'"> '.__('Ask users to confirm their subscription', 'subscribedownload').'
											<br /><em>'.__('Control whether a double opt-in confirmation message is sent.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Send Welcome', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_mailchimp_welcome" name="subscribedownload_mailchimp_welcome" '.($this->options['mailchimp_welcome'] == "on" ? 'checked="checked"' : '').'"> '.__('Send Lists Welcome message', 'subscribedownload').'
											<br /><em>'.__('If your <strong>Double opt-in</strong> is disabled and this is enabled, MailChimp will send your lists Welcome Email if this subscribe succeeds. If <strong>Double opt-in</strong> is enabled, this has no effect.', 'subscribedownload').'</em>
										</td>
									</tr>
								</table>
								<div class="alignright">
								<input type="submit" class="subscribedownload_button button-primary" name="submit" value="'.__('Update Settings', 'subscribedownload').'">
								</div>
							</div>
						</div>
						<div class="postbox subscribedownload_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('iContact Settings', 'subscribedownload').'</span></h3>
							<div class="inside">
								<table class="subscribedownload_useroptions">
									<tr>
										<th>'.__('Enable iContact', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_icontact_enable" name="subscribedownload_icontact_enable" '.($this->options['icontact_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to iContact', 'subscribedownload').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to iContact.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('AppID', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_icontact_appid" name="subscribedownload_icontact_appid" value="'.htmlspecialchars($this->options['icontact_appid'], ENT_QUOTES).'" class="widefat subscribedownload-input" onchange="subscribedownload_icontact_handler();">
											<br /><em>'.__('Obtained when you <a href="http://developer.icontact.com/documentation/register-your-app/" target="_blank">Register the API application</a>. This identifier is used to uniquely identify your application.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('API Username', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_icontact_apiusername" name="subscribedownload_icontact_apiusername" value="'.htmlspecialchars($this->options['icontact_apiusername'], ENT_QUOTES).'" class="widefat subscribedownload-input" onchange="subscribedownload_icontact_handler();">
											<br /><em>'.__('The iContact username for logging into your iContact account.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('API Password', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_icontact_apipassword" name="subscribedownload_icontact_apipassword" value="'.htmlspecialchars($this->options['icontact_apipassword'], ENT_QUOTES).'" class="widefat subscribedownload-input" onchange="subscribedownload_icontact_handler();">
											<br /><em>'.__('The API application password set when the application was registered. This API password is used as input when your application authenticates to the API. This password is not the same as the password you use to log in to iContact.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('List ID', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_icontact_listid" name="subscribedownload_icontact_listid" value="'.esc_attr($this->options['icontact_listid']).'" class="widefat subscribedownload-input">
											<br /><em>'.__('Enter your List ID. You can get List ID from', 'subscribedownload').' <a href="'.admin_url('admin.php').'?action=subscribedownload-icontact-lists&appid='.base64_encode($this->options['icontact_appid']).'&user='.base64_encode($this->options['icontact_apiusername']).'&pass='.base64_encode($this->options['icontact_apipassword']).'" class="thickbox" id="subscribedownload_icontact_lists" title="'.__('Available Lists', 'subscribedownload').'">'.__('this table', 'subscribedownload').'</a>.</em>
										</td>
									</tr>
								</table>
								<div class="alignright">
								<input type="submit" class="subscribedownload_button button-primary" name="submit" value="'.__('Update Settings', 'subscribedownload').'">
								</div>
							</div>
						</div>
						<div class="postbox subscribedownload_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('GetResponse Settings', 'subscribedownload').'</span></h3>
							<div class="inside">
								<table class="subscribedownload_useroptions">
									<tr>
										<th>'.__('Enable GetResponse', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_getresponse_enable" name="subscribedownload_getresponse_enable" '.($this->options['getresponse_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to GetResponse', 'subscribedownload').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to GetResponse.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('API Key', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_getresponse_api_key" name="subscribedownload_getresponse_api_key" value="'.esc_attr($this->options['getresponse_api_key']).'" class="widefat subscribedownload-input" onchange="subscribedownload_getresponse_handler();">
											<br /><em>'.__('Enter your GetResponse API Key. You can get your API Key <a href="https://app.getresponse.com/my_api_key.html" target="_blank">here</a>.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Campaign ID', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_getresponse_campaign_id" name="subscribedownload_getresponse_campaign_id" value="'.esc_attr($this->options['getresponse_campaign_id']).'" class="widefat subscribedownload-input">
											<br /><em>'.__('Enter your Campaign ID. You can get Campaign ID from', 'subscribedownload').' <a href="'.admin_url('admin.php').'?action=subscribedownload-getresponse-campaigns&key='.base64_encode($this->options['getresponse_api_key']).'" class="thickbox" id="subscribedownload_getresponse_campaigns" title="'.__('Available Campaigns', 'subscribedownload').'">'.__('this table', 'subscribedownload').'</a>.</em>
										</td>
									</tr>
								</table>
								<div class="alignright">
								<input type="submit" class="subscribedownload_button button-primary" name="submit" value="'.__('Update Settings', 'subscribedownload').'">
								</div>
							</div>
						</div>
						<div class="postbox subscribedownload_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('Campaign Monitor Details', 'subscribedownload').'</span></h3>
							<div class="inside">
								<table class="subscribedownload_useroptions">
									<tr>
										<th>'.__('Enable Campaign Monitor', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_campaignmonitor_enable" name="subscribedownload_campaignmonitor_enable" '.($this->options['campaignmonitor_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to Campaign Monitor', 'subscribedownload').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to Campaign Monitor.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('API Key', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_campaignmonitor_api_key" name="subscribedownload_campaignmonitor_api_key" value="'.esc_attr($this->options['campaignmonitor_api_key']).'" class="widefat">
											<br /><em>'.__('Enter your Campaign Monitor API Key. You can get your API Key from the Account Settings page when logged into your Campaign Monitor account.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('List ID', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_campaignmonitor_list_id" name="subscribedownload_campaignmonitor_list_id" value="'.esc_attr($this->options['campaignmonitor_list_id']).'" class="widefat">
											<br /><em>'.__('Enter your List ID. You can get List ID from the list editor page when logged into your Campaign Monitor account.', 'subscribedownload').'</em>
										</td>
									</tr>
								</table>
								<div class="alignright">
								<input type="submit" class="subscribedownload_button button-primary" name="submit" value="'.__('Update Settings', 'subscribedownload').'">
								</div>
							</div>
						</div>
						<div class="postbox subscribedownload_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('Mad Mimi Settings', 'subscribedownload').'</span></h3>
							<div class="inside">
								<table class="subscribedownload_useroptions">
									<tr>
										<th>'.__('Enable Mad Mimi', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_madmimi_enable" name="subscribedownload_madmimi_enable" '.($this->options['madmimi_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to Mad Mimi', 'subscribedownload').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to Mad Mimi.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Username/E-mail', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_madmimi_login" name="subscribedownload_madmimi_login" value="'.esc_attr($this->options['madmimi_login']).'" class="widefat subscribedownload-input" onchange="subscribedownload_madmimi_handler();">
											<br /><em>'.__('Enter your Mad Mimi username/e-mail.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('API Key', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_madmimi_api_key" name="subscribedownload_madmimi_api_key" value="'.esc_attr($this->options['madmimi_api_key']).'" class="widefat subscribedownload-input" onchange="subscribedownload_madmimi_handler();">
											<br /><em>'.__('Enter your Mad Mimi API Key. You can get your API Key <a href="https://madmimi.com/user/edit?account_info_tabs=account_info_personal" target="_blank">here</a>.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('List ID', 'subscribedownload').':</th>
										<td>
											<input type="text" id="subscribedownload_madmimi_list_id" name="subscribedownload_madmimi_list_id" value="'.esc_attr($this->options['madmimi_list_id']).'" class="widefat subscribedownload-input">
											<br /><em>'.__('Enter your List ID. You can get List ID from', 'subscribedownload').' <a href="'.admin_url('admin.php').'?action=subscribedownload-madmimi-lists&login='.base64_encode($this->options['madmimi_login']).'&key='.base64_encode($this->options['madmimi_api_key']).'" class="thickbox" id="subscribedownload_madmimi_lists" title="'.__('Available Lists', 'subscribedownload').'">'.__('this table', 'subscribedownload').'</a>.</em>
										</td>
									</tr>
								</table>
								<div class="alignright">
								<input type="submit" class="subscribedownload_button button-primary" name="submit" value="'.__('Update Settings', 'subscribedownload').'">
								</div>
							</div>
						</div>
						<div class="postbox subscribedownload_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('AWeber Details', 'subscribedownload').'</span></h3>
							<div class="inside">
								<table class="subscribedownload_useroptions">
									<tr>
										<th>'.__('Enable AWeber', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_aweber_enable" name="subscribedownload_aweber_enable" '.($this->options['aweber_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to AWeber', 'subscribedownload').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to AWeber.', 'subscribedownload').'</em>
										</td>
									</tr>';
		$account = null;
		if ($this->options['aweber_access_secret']) {
			if (!class_exists('AWeberAPI')) {
				require_once(dirname(__FILE__).'/aweber_api/aweber_api.php');
			}
			try {
				$aweber = new AWeberAPI($this->options['aweber_consumer_key'], $this->options['aweber_consumer_secret']);
				$account = $aweber->getAccount($this->options['aweber_access_key'], $this->options['aweber_access_secret']);
			} catch (AWeberException $e) {
				$account = null;
			}
		}
		if (!$account) {
			echo '
									<tbody id="subscribedownload-aweber-group">
										<tr>
											<th>'.__('Authorization code', 'subscribedownload').':</th>
											<td>
												<input type="text" id="subscribedownload_aweber_oauth_id" value="" class="widefat" placeholder="AWeber authorization code">
												<br />Get your authorization code <a target="_blank" href="https://auth.aweber.com/1.0/oauth/authorize_app/'.SUBSCRIBEDOWNLOAD_AWEBER_APPID.'">'.__('here', 'subscribedownload').'</a>.
											</td>
										</tr>
										<tr>
											<th></th>
											<td style="vertical-align: middle;">
												<input type="button" class="subscribedownload_button button-secondary" value="'.__('Make Connection', 'subscribedownload').'" onclick="return subscribedownload_aweber_connect();" >
												<img id="subscribedownload-aweber-loading" src="'.plugins_url('/images/loading.gif', __FILE__).'">
											</td>
										</tr>
									</tbody>';
		} else {
			echo '
									<tbody id="subscribedownload-aweber-group">
										<tr>
											<th>'.__('Connected', 'subscribedownload').':</th>
											<td>
												<input type="button" class="subscribedownload_button button-secondary" value="'.__('Disconnect', 'subscribedownload').'" onclick="return subscribedownload_aweber_disconnect();" >
												<img id="subscribedownload-aweber-loading" src="'.plugins_url('/images/loading.gif', __FILE__).'">
												<br /><em>'.__('Click the button to disconnect.', 'subscribedownload').'</em>
											</td>
										</tr>
										<tr>
											<th>'.__('List ID', 'subscribedownload').':</th>
											<td>
												<select name="subscribedownload_aweber_listid" style="width: 40%;">
													<option value="">'.__('--- Select List ID ---', 'subscribedownload').'</option>';
				$lists = $account->lists;
				foreach ($lists as $list) {
					echo '
													<option value="'.$list->id.'"'.($list->id == $this->options['aweber_listid'] ? ' selected="selected"' : '').'>'.$list->name.'</option>';
				}
				echo '
												</select>
												<br /><em>'.__('Select your List ID.', 'subscribedownload').'</em>
											</td>
										</tr>
									</tbody>';
		}
		echo '
								</table>
								<div id="subscribedownload-aweber-message"></div>
								<div class="alignright">
								<input type="submit" class="subscribedownload_button button-primary" name="submit" value="'.__('Update Settings', 'subscribedownload').'">
								</div>
							</div>
						</div>';
		if (function_exists('mymail_subscribe') || function_exists('mymail')) {
			echo '
						<div class="postbox subscribedownload_postbox">
							<h3 class="hndle" style="cursor: default;"><span>'.__('MyMail Settings', 'subscribedownload').'</span></h3>
							<div class="inside">
								<table class="subscribedownload_useroptions">';
			if (function_exists('mymail')) {
				$lists = mymail('lists')->get();
				$create_list_url = 'edit.php?post_type=newsletter&page=mymail_lists';
			} else {
				$lists = get_terms('newsletter_lists', array('hide_empty' => false));
				$create_list_url = 'edit-tags.php?taxonomy=newsletter_lists&post_type=newsletter';
			}
			if (sizeof($lists) == 0) {
				echo '
									<tr>
										<th>'.__('Enable MyMail', 'subscribedownload').':</th>
										<td>'.__('Please', 'subscribedownload').' <a href="'.$create_list_url.'">'.__('create', 'subscribedownload').'</a> '.__('at least one list.', 'subscribedownload').'</td>
									</tr>';
			} else {
				echo '
									<tr>
										<th>'.__('Enable MyMail', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_mymail_enable" name="subscribedownload_mymail_enable" '.($this->options['mymail_enable'] == "on" ? 'checked="checked"' : '').'"> '.__('Submit contact details to MyMail', 'subscribedownload').'
											<br /><em>'.__('Please tick checkbox if you want to submit contact details to MyMail.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('List ID', 'subscribedownload').':</th>
										<td>
											<select name="subscribedownload_mymail_listid" class="ic_input_m">';
				foreach ($lists as $list) {
					if (function_exists('mymail')) $id = $list->ID;
					else $id = $list->term_id;
					echo '
												<option value="'.$id.'"'.($id == $this->options['mymail_listid'] ? ' selected="selected"' : '').'>'.$list->name.'</option>';
				}
				echo '
											</select>
											<br /><em>'.__('Select your List ID.', 'subscribedownload').'</em>
										</td>
									</tr>
									<tr>
										<th>'.__('Double Opt-In', 'subscribedownload').':</th>
										<td>
											<input type="checkbox" id="subscribedownload_mymail_double" name="subscribedownload_mymail_double" '.($this->options['mymail_double'] == "on" ? 'checked="checked"' : '').'"> '.__('Enable Double Opt-In', 'subscribedownload').'
											<br /><em>'.__('Please tick checkbox if you want to enable double opt-in feature.', 'subscribedownload').'</em>
										</td>
									</tr>';
			}
			echo '
								</table>
								<div class="alignright">
								<input type="submit" class="subscribedownload_button button-primary" name="submit" value="'.__('Update Settings', 'subscribedownload').'">
								</div>
							</div>
						</div>';
		}
		echo '
					</div>
				</div>
			</div>
			</form>
		</div>
		<script type="text/javascript">
			function subscribedownload_aweber_connect() {
				jQuery("#subscribedownload-aweber-loading").fadeIn(350);
				jQuery("#subscribedownload-aweber-message").slideUp(350);
				var data = {action: "subscribedownload_aweber_connect", subscribedownload_aweber_oauth_id: jQuery("#subscribedownload_aweber_oauth_id").val()};
				jQuery.post("'.admin_url('admin-ajax.php').'", data, function(return_data) {
					jQuery("#subscribedownload-aweber-loading").fadeOut(350);
					try {
						//alert(return_data);
						var data = jQuery.parseJSON(return_data);
						var status = data.status;
						if (status == "OK") {
							jQuery("#subscribedownload-aweber-group").slideUp(350, function() {
								jQuery("#subscribedownload-aweber-group").html(data.html);
								jQuery("#subscribedownload-aweber-group").slideDown(350);
							});
						} else if (status == "ERROR") {
							jQuery("#subscribedownload-aweber-message").html(data.message);
							jQuery("#subscribedownload-aweber-message").slideDown(350);
						} else {
							jQuery("#subscribedownload-aweber-message").html("Service is not available.");
							jQuery("#subscribedownload-aweber-message").slideDown(350);
						}
					} catch(error) {
						jQuery("#subscribedownload-aweber-message").html("Service is not available.");
						jQuery("#subscribedownload-aweber-message").slideDown(350);
					}
				});
				return false;
			}
			function subscribedownload_aweber_disconnect() {
				jQuery("#subscribedownload-aweber-loading").fadeIn(350);
				var data = {action: "subscribedownload_aweber_disconnect"};
					jQuery.post("'.admin_url('admin-ajax.php').'", data, function(return_data) {
					jQuery("#subscribedownload-aweber-loading").fadeOut(350);
					try {
						//alert(return_data);
						var data = jQuery.parseJSON(return_data);
						var status = data.status;
						if (status == "OK") {
							jQuery("#subscribedownload-aweber-group").slideUp(350, function() {
								jQuery("#subscribedownload-aweber-group").html(data.html);
								jQuery("#subscribedownload-aweber-group").slideDown(350);
							});
						} else if (status == "ERROR") {
							jQuery("#subscribedownload-aweber-message").html(data.message);
							jQuery("#subscribedownload-aweber-message").slideDown(350);
						} else {
							jQuery("#subscribedownload-aweber-message").html("Service is not available.");
							jQuery("#subscribedownload-aweber-message").slideDown(350);
						}
					} catch(error) {
						jQuery("#subscribedownload-aweber-message").html("Service is not available.");
						jQuery("#subscribedownload-aweber-message").slideDown(350);
					}
				});
				return false;
			}
			function subscribedownload_getresponse_handler() {
				jQuery("#subscribedownload_getresponse_campaigns").attr("href", "'.admin_url('admin.php').'?action=subscribedownload-getresponse-campaigns&key="+subscribedownload_encode64(jQuery("#subscribedownload_getresponse_api_key").val()));
			}
			function subscribedownload_icontact_handler() {
				jQuery("#subscribedownload_icontact_lists").attr("href", "'.admin_url('admin.php').'?action=subscribedownload-icontact-lists&appid="+subscribedownload_encode64(jQuery("#subscribedownload_icontact_appid").val())+"&user="+subscribedownload_encode64(jQuery("#subscribedownload_icontact_apiusername").val())+"&pass="+subscribedownload_encode64(jQuery("#subscribedownload_icontact_apipassword").val()));
			}
			function subscribedownload_madmimi_handler() {
				jQuery("#subscribedownload_madmimi_lists").attr("href", "'.admin_url('admin.php').'?action=subscribedownload-madmimi-lists&login="+subscribedownload_encode64(jQuery("#subscribedownload_madmimi_login").val())+"&key="+subscribedownload_encode64(jQuery("#subscribedownload_madmimi_api_key").val()));
			}
			jQuery(document).ready(function(){
				jQuery(".subscribedownload-color").wpColorPicker();
			});
		</script>';
	}

	function aweber_connect() {
		global $wpdb;
		if (current_user_can('manage_options')) {
			if (!isset($_POST['subscribedownload_aweber_oauth_id']) || empty($_POST['subscribedownload_aweber_oauth_id'])) {
				$return_object = array();
				$return_object['status'] = 'ERROR';
				$return_object['message'] = __('Authorization Code not found.', 'subscribedownload');
				echo json_encode($return_object);
				exit;
			}
			$code = trim(stripslashes($_POST['subscribedownload_aweber_oauth_id']));
			if (!class_exists('AWeberAPI')) {
				require_once(dirname(__FILE__).'/aweber_api/aweber_api.php');
			}
			$account = null;
			try {
				list($consumer_key, $consumer_secret, $access_key, $access_secret) = AWeberAPI::getDataFromAweberID($code);
			} catch (AWeberAPIException $exc) {
				list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
			} catch (AWeberOAuthDataMissing $exc) {
				list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
			} catch (AWeberException $exc) {
				list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
			}
			if (!$access_secret) {
				$return_object = array();
				$return_object['status'] = 'ERROR';
				$return_object['message'] = __('Invalid Authorization Code!', 'subscribedownload');
				echo json_encode($return_object);
				exit;
			} else {
				try {
					$aweber = new AWeberAPI($consumer_key, $consumer_secret);
					$account = $aweber->getAccount($access_key, $access_secret);
				} catch (AWeberException $e) {
					$return_object = array();
					$return_object['status'] = 'ERROR';
					$return_object['message'] = __('Can not access AWeber account!', 'subscribedownload');
					echo json_encode($return_object);
					exit;
				}
			}
			$this->options['aweber_consumer_key'] = $consumer_key;
			$this->options['aweber_consumer_secret'] = $consumer_secret;
			$this->options['aweber_access_key'] = $access_key;
			$this->options['aweber_access_secret'] = $access_secret;
			$this->update_options();
			$return_object = array();
			$return_object['status'] = 'OK';
			$return_object['html'] = '
										<tr>
											<th>'.__('Connected', 'subscribedownload').':</th>
											<td>
												<input type="button" class="subscribedownload_button button-secondary" value="'.__('Disconnect', 'subscribedownload').'" onclick="return subscribedownload_aweber_disconnect();" >
												<img id="subscribedownload-aweber-loading" src="'.plugins_url('/images/loading.gif', __FILE__).'">
												<br /><em>'.__('Click the button to disconnect.', 'subscribedownload').'</em>
											</td>
										</tr>
										<tr>
											<th>'.__('List ID', 'subscribedownload').':</th>
											<td>
												<select name="subscribedownload_aweber_listid" style="width: 40%;">
													<option value="">'.__('--- Select List ID ---', 'subscribedownload').'</option>';
				$lists = $account->lists;
				foreach ($lists as $list) {
					$return_object['html'] .= '
													<option value="'.$list->id.'"'.($list->id == $this->options['aweber_listid'] ? ' selected="selected"' : '').'>'.$list->name.'</option>';
				}
				$return_object['html'] .= '
												</select>
												<br /><em>'.__('Select your List ID.', 'subscribedownload').'</em>
											</td>
										</tr>';
			echo json_encode($return_object);
			exit;
		}
		exit;
	}
	
	function aweber_disconnect() {
		global $wpdb;
		if (current_user_can('manage_options')) {
			$this->options['aweber_consumer_key'] = '';
			$this->options['aweber_consumer_secret'] = '';
			$this->options['aweber_access_key'] = '';
			$this->options['aweber_access_secret'] = '';
			$this->update_options();
			$return_object = array();
			$return_object['status'] = 'OK';
			$return_object['html'] = '
					<tr>
						<th>'.__('Authorization code', 'subscribedownload').':</th>
						<td>
							<input type="text" id="subscribedownload_aweber_oauth_id" value="" class="widefat" placeholder="AWeber authorization code">
							<br />Get your authorization code <a target="_blank" href="https://auth.aweber.com/1.0/oauth/authorize_app/'.SUBSCRIBEDOWNLOAD_AWEBER_APPID.'">'.__('here', 'subscribedownload').'</a>.
						</td>
					</tr>
					<tr>
						<th></th>
						<td style="vertical-align: middle;">
							<input type="button" class="subscribedownload_button button-secondary" value="'.__('Make Connection', 'subscribedownload').'" onclick="return subscribedownload_aweber_connect();" >
							<img id="subscribedownload-aweber-loading" src="'.plugins_url('/images/loading.gif', __FILE__).'">
						</td>
					</tr>';
			echo json_encode($return_object);
			exit;
		}
		exit;
	}
	
	function admin_users() {
		global $wpdb;

		if (isset($_GET["s"])) $search_query = trim(stripslashes($_GET["s"]));
		else $search_query = "";
		
		$tmp = $wpdb->get_row("SELECT COUNT(*) AS total FROM ".$wpdb->prefix."sad_users WHERE deleted = '0'".((strlen($search_query) > 0) ? " AND (name LIKE '%".addslashes($search_query)."%' OR email LIKE '%".addslashes($search_query)."%')" : ""), ARRAY_A);
		$total = $tmp["total"];
		$totalpages = ceil($total/SUBSCRIBEDOWNLOAD_RECORDS_PER_PAGE);
		if ($totalpages == 0) $totalpages = 1;
		if (isset($_GET["p"])) $page = intval($_GET["p"]);
		else $page = 1;
		if ($page < 1 || $page > $totalpages) $page = 1;
		$switcher = $this->page_switcher(admin_url('admin.php')."?page=subscribedownload-users".((strlen($search_query) > 0) ? "&s=".rawurlencode($search_query) : ""), $page, $totalpages);

		$sql = "SELECT * FROM ".$wpdb->prefix."sad_users WHERE deleted = '0'".((strlen($search_query) > 0) ? " AND (name LIKE '%".addslashes($search_query)."%' OR email LIKE '%".addslashes($search_query)."%')" : "")." ORDER BY registered DESC LIMIT ".(($page-1)*SUBSCRIBEDOWNLOAD_RECORDS_PER_PAGE).", ".SUBSCRIBEDOWNLOAD_RECORDS_PER_PAGE;
		$rows = $wpdb->get_results($sql, ARRAY_A);
		if (isset($_GET['deleted'])) $message = "<div class='updated'><p>".__('Record successfully deleted!', 'subscribedownload')."</p></div>";
		else $message = '';

		print ('
			<div class="wrap admin_subscribedownload_wrap">
				<div id="icon-users" class="icon32"><br /></div><h2>'.__('Subscribe & Download - Users', 'subscribedownload').'</h2><br />
				'.$message.'
				<form action="'.admin_url('admin.php').'" method="get" style="margin-bottom: 10px;">
				<input type="hidden" name="page" value="subscribedownload-users" />
				'.__('Search:', 'subscribedownload').' <input type="text" name="s" value="'.htmlspecialchars($search_query, ENT_QUOTES).'">
				<input type="submit" class="button-secondary action" value="'.__('Search', 'subscribedownload').'" />
				'.((strlen($search_query) > 0) ? '<input type="button" class="button-secondary action" value="'.__('Reset search results', 'subscribedownload').'" onclick="window.location.href=\''.admin_url('admin.php').'?page=subscribedownload-users\';" />' : '').'
				</form>
				<div class="subscribedownload_buttons"><a class="button" href="'.admin_url('admin.php').'?action=subscribedownload-csv">'.__('CSV Export', 'subscribedownload').'</a></div>
				<div class="subscribedownload_pageswitcher">'.$switcher.'</div>
				<table class="subscribedownload_users">
				<tr>
					<th>'.__('Name', 'subscribedownload').'</th>
					<th>'.__('E-mail', 'subscribedownload').'</th>
					<th>'.__('URL', 'subscribedownload').'</th>
					<th style="width: 120px;">'.__('Registered', 'subscribedownload').'</th>
					<th style="width: 25px;"></th>
				</tr>');
		if (sizeof($rows) > 0) {
			foreach ($rows as $row) {
				print ('
				<tr>
					<td>'.($row['name'] == '' ? '-' : esc_attr($row['name'])).'</td>
					<td>'.esc_attr($row['email']).'</td>
					<td>'.esc_attr($row['url']).'</td>
					<td>'.date("Y-m-d H:i", $row['registered']).'</td>
					<td style="text-align: center;">
						<a href="'.admin_url('admin.php').'?action=subscribedownload-delete&id='.$row['id'].'" title="'.__('Delete record', 'subscribedownload').'" onclick="return subscribedownload_submitOperation();"><img src="'.plugins_url('/images/delete.png', __FILE__).'" alt="'.__('Delete record', 'subscribedownload').'" border="0"></a>
					</td>
				</tr>
				');
			}
		} else {
			print ('
				<tr><td colspan="5" style="padding: 20px; text-align: center;">'.((strlen($search_query) > 0) ? __('No results found for', 'subscribedownload').' "<strong>'.htmlspecialchars($search_query, ENT_QUOTES).'</strong>"' : __('List is empty.', 'subscribedownload')).'</td></tr>');
		}
		print ('
				</table>
				<div class="subscribedownload_buttons">
					<a class="button" href="'.admin_url('admin.php').'?action=subscribedownload-deleteall" onclick="return subscribedownload_submitOperation();">'.__('Delete All', 'subscribedownload').'</a>
					<a class="button" href="'.admin_url('admin.php').'?action=subscribedownload-csv">'.__('CSV Export', 'subscribedownload').'</a>
				</div>
				<div class="subscribedownload_pageswitcher">'.$switcher.'</div>
				<div class="subscribedownload_legend">
				<strong>'.__('Legend', 'subscribedownload').':</strong>
					<p><img src="'.plugins_url('/images/delete.png', __FILE__).'" alt="'.__('Delete record', 'subscribedownload').'" border="0"> '.__('Delete record', 'subscribedownload').'</p>
				</div>
			</div>
			<script type="text/javascript">
				function subscribedownload_submitOperation() {
					var answer = confirm("'.__('Do you really want to continue?', 'subscribedownload').'")
					if (answer) return true;
					else return false;
				}
			</script>');
	}
	
	function admin_request_handler() {
		global $wpdb;
		if (!empty($_POST['action'])) {
			switch($_POST['action']) {
				case 'subscribedownload-update-options':
					$this->populate_options();
					if (isset($_POST["subscribedownload_mailchimp_double"])) $this->options['mailchimp_double'] = "on";
					else $this->options['mailchimp_double'] = "off";
					if (isset($_POST["subscribedownload_mailchimp_welcome"])) $this->options['mailchimp_welcome'] = "on";
					else $this->options['mailchimp_welcome'] = "off";
					if (isset($_POST["subscribedownload_mailchimp_enable"])) $this->options['mailchimp_enable'] = "on";
					else $this->options['mailchimp_enable'] = "off";
					if (isset($_POST["subscribedownload_icontact_enable"])) $this->options['icontact_enable'] = "on";
					else $this->options['icontact_enable'] = "off";
					if (isset($_POST["subscribedownload_campaignmonitor_enable"])) $this->options['campaignmonitor_enable'] = "on";
					else $this->options['campaignmonitor_enable'] = "off";
					if (isset($_POST["subscribedownload_getresponse_enable"])) $this->options['getresponse_enable'] = "on";
					else $this->options['getresponse_enable'] = "off";
					if (isset($_POST["subscribedownload_aweber_enable"])) $this->options['aweber_enable'] = "on";
					else $this->options['aweber_enable'] = "off";
					if (isset($_POST["subscribedownload_madmimi_enable"])) $this->options['madmimi_enable'] = "on";
					else $this->options['madmimi_enable'] = "off";
					if (isset($_POST["subscribedownload_mymail_enable"])) $this->options['mymail_enable'] = "on";
					else $this->options['mymail_enable'] = "off";
					if (isset($_POST["subscribedownload_mymail_double"])) $this->options['mymail_double'] = "on";
					else $this->options['mymail_double'] = "off";
					if (isset($_POST["subscribedownload_disable_name"])) $this->options['disable_name'] = "on";
					else $this->options['disable_name'] = "off";
					if (isset($_POST['subscribedownload_email_validation'])) $this->options['email_validation'] = 'on';
					else $this->options['email_validation'] = 'off';
					if (isset($_POST['subscribedownload_ga_tracking'])) $this->options['ga_tracking'] = 'on';
					else $this->options['ga_tracking'] = 'off';
					if (isset($_POST['subscribedownload_mail_enable'])) $this->options['mail_enable'] = "on";
					else $this->options['mail_enable'] = "off";
					
					$this->update_options();
					$errors = $this->check_options();
					if (!is_array($errors)) header('Location: '.admin_url('admin.php').'?page=subscribedownload&updated=true');
					else header('Location: '.admin_url('admin.php').'?page=subscribedownload');
					die();
					break;
				default:
					break;
			}
		}
		if (isset($_GET['action'])) {
			switch($_GET['action']) {
				case 'subscribedownload-delete':
					$id = intval($_GET["id"]);
					$user_details = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."sad_users WHERE id = '".$id."' AND deleted = '0'", ARRAY_A);
					if (intval($user_details["id"]) == 0) {
						header('Location: '.admin_url('admin.php').'?page=subscribedownload-users');
						die();
					}
					$sql = "UPDATE ".$wpdb->prefix."sad_users SET deleted = '1' WHERE id = '".$id."'";
					if ($wpdb->query($sql) !== false) {
						header('Location: '.admin_url('admin.php').'?page=subscribedownload-users&deleted=1');
					} else {
						header('Location: '.admin_url('admin.php').'?page=subscribedownload-users');
					}
					die();
					break;
				case 'subscribedownload-csv':
					$rows = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."sad_users WHERE deleted = '0' ORDER BY registered DESC", ARRAY_A);
					if (sizeof($rows) > 0) {
						if (strstr($_SERVER["HTTP_USER_AGENT"],"MSIE")) {
							header("Pragma: public");
							header("Expires: 0");
							header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
							header("Content-type: application-download");
							header("Content-Disposition: attachment; filename=\"emails.csv\"");
							header("Content-Transfer-Encoding: binary");
						} else {
							header("Content-type: application-download");
							header("Content-Disposition: attachment; filename=\"emails.csv\"");
						}
						$separator = $this->options['csv_separator'];
						if ($separator == 'tab') $separator = "\t";
						echo '"Name"'.$separator.'"E-Mail"'.$separator.'"Registered"'.$separator.'"URL"'."\r\n";
						foreach ($rows as $row) {
							echo '"'.str_replace('"', '', $row["name"]).'"'.$separator.'"'.str_replace('"', "", $row["email"]).'"'.$separator.'"'.date("Y-m-d H:i:s", $row["registered"]).'"'.$separator.'"'.str_replace('"', '', $row["url"]).'"'."\r\n";
						}
						die();
		            }
		            header("Location: ".admin_url('admin.php')."?page=subscribedownload");
					die();
					break;
				case 'subscribedownload-deleteall':
					$sql = "UPDATE ".$wpdb->prefix."sad_users SET deleted = '1'";
					if ($wpdb->query($sql) !== false) {
						header('Location: '.admin_url('admin.php').'?page=subscribedownload-users&deleted=1');
					} else {
						header('Location: '.admin_url('admin.php').'?page=subscribedownload-users');
					}
					die();
					break;
				case 'subscribedownload-getresponse-campaigns':
					if (isset($_GET["key"]) && !empty($_GET["key"])) {
						$key = base64_decode($_GET["key"]);
						$request = json_encode(
							array(
								'method' => 'get_campaigns',
								'params' => array(
									$key
								),
								'id' => ''
							)
						);

						$curl = curl_init('https://api2.getresponse.com/');
						curl_setopt($curl, CURLOPT_POST, 1);
						curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
						$header = array(
							'Content-Type: application/json',
							'Content-Length: '.strlen($request)
						);
						curl_setopt($curl, CURLOPT_PORT, 443);
						curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
						curl_setopt($curl, CURLOPT_TIMEOUT, 10);
						curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 1); // verify certificate
						curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2); // check existence of CN and verify that it matches hostname
						curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
						curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
						curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
						curl_setopt($curl, CURLOPT_HEADER, 0);
									
						$response = curl_exec($curl);
						
						if (curl_error($curl)) die('<div style="text-align: center; margin: 20px 0px;">'.__('API call failed.','subscribedownload').'</div>');
						$httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
						if ($httpCode != '200') die('<div style="text-align: center; margin: 20px 0px;">'.__('API call failed.','subscribedownload').'</div>');
						curl_close($curl);
						
						$post = json_decode($response, true);
						if(!empty($post['error'])) die('<div style="text-align: center; margin: 20px 0px;">'.__('API Key failed','subscribedownload').': '.$post['error']['message'].'</div>');
						
						if (!empty($post['result'])) {
							echo '
<html>
<head>
	<meta name="robots" content="noindex, nofollow, noarchive, nosnippet">
	<title>'.__('GetResponse Campaigns', 'subscribedownload').'</title>
</head>
<body>
	<table style="width: 100%;">
		<tr>
			<td style="width: 170px; font-weight: bold;">'.__('Campaign ID', 'subscribedownload').'</td>
			<td style="font-weight: bold;">'.__('Campaign Name', 'subscribedownload').'</td>
		</tr>';
							foreach ($post['result'] as $key => $value) {
								echo '
		<tr>
			<td>'.esc_attr($key).'</td>
			<td>'.esc_attr(esc_attr($value['name'])).'</td>
		</tr>';
							}
							echo '
	</table>						
</body>
</html>';
						} else echo '<div style="text-align: center; margin: 20px 0px;">'.__('No data found!', 'subscribedownload').'</div>';
					} else echo '<div style="text-align: center; margin: 20px 0px;">'.__('No data found!', 'subscribedownload').'</div>';
					die();
					break;
				case 'subscribedownload-icontact-lists':
					if (isset($_GET["appid"]) && isset($_GET["user"]) && isset($_GET["pass"])) {
						$this->options['icontact_appid'] = base64_decode($_GET["appid"]);
						$this->options['icontact_apiusername'] = base64_decode($_GET["user"]);
						$this->options['icontact_apipassword'] = base64_decode($_GET["pass"]);
						
						$lists = $this->icontact_getlists();
						if (!empty($lists)) {
							echo '
<html>
<head>
	<meta name="robots" content="noindex, nofollow, noarchive, nosnippet">
	<title>'.__('GetResponse Campaigns', 'subscribedownload').'</title>
</head>
<body>
	<table style="width: 100%;">
		<tr>
			<td style="width: 170px; font-weight: bold;">'.__('List ID', 'subscribedownload').'</td>
			<td style="font-weight: bold;">'.__('List Name', 'subscribedownload').'</td>
		</tr>';
							foreach ($lists as $key => $value) {
								echo '
		<tr>
			<td>'.esc_attr($key).'</td>
			<td>'.esc_attr(esc_attr($value)).'</td>
		</tr>';
							}
							echo '
	</table>						
</body>
</html>';
						} else echo '<div style="text-align: center; margin: 20px 0px;">'.__('No data found!', 'subscribedownload').'</div>';
					} else echo '<div style="text-align: center; margin: 20px 0px;">'.__('No data found!', 'subscribedownload').'</div>';
					die();
					break;
				case 'subscribedownload-madmimi-lists':
					if (isset($_GET["login"]) && isset($_GET["key"])) {
						$login = base64_decode($_GET["login"]);
						$key = base64_decode($_GET["key"]);
						
						$lists = $this->madmimi_getlists($login, $key);
						if (!empty($lists)) {
							echo '
<html>
<head>
	<meta name="robots" content="noindex, nofollow, noarchive, nosnippet">
	<title>'.__('Mad Mimi Lists', 'subscribedownload').'</title>
</head>
<body>
	<table style="width: 100%;">
		<tr>
			<td style="width: 170px; font-weight: bold;">'.__('List ID', 'subscribedownload').'</td>
			<td style="font-weight: bold;">'.__('List Name', 'subscribedownload').'</td>
		</tr>';
							foreach ($lists as $key => $value) {
								echo '
		<tr>
			<td>'.esc_attr($key).'</td>
			<td>'.esc_attr(esc_attr($value)).'</td>
		</tr>';
							}
							echo '
	</table>						
</body>
</html>';
						} else echo '<div style="text-align: center; margin: 20px 0px;">'.__('No data found!', 'subscribedownload').'</div>';
					} else echo '<div style="text-align: center; margin: 20px 0px;">'.__('No data found!', 'subscribedownload').'</div>';
					die();
					break;
				default:
					break;
			}
		}
	}

	function admin_warning() {
		echo '
		<div class="updated"><p>'.__('<strong>Subscribe & Download plugin almost ready.</strong> You must do some', 'subscribedownload').' <a href="'.admin_url('admin.php').'?page=subscribedownload">'.__('settings', 'subscribedownload').'</a> '.__('for it to work.', 'subscribedownload').'</p></div>';
	}

	function front_header() {
		global $post, $wpdb, $current_user;
		
		$from = $this->get_rgb($this->options['button_color']);
		$total = $from['r']+$from['g']+$from['b'];
		if ($total == 0) $total = 1;
		$to = array();
		$to['r'] = max(0, $from['r']-intval(48*$from['r']/$total));
		$to['g'] = max(0, $from['g']-intval(48*$from['g']/$total));
		$to['b'] = max(0, $from['b']-intval(48*$from['b']/$total));
		$to_color = '#'.($to['r'] < 16 ? '0' : '').dechex($to['r']).($to['g'] < 16 ? '0' : '').dechex($to['g']).($to['b'] < 16 ? '0' : '').dechex($to['b']);
		$from_color = $this->options['button_color'];
		if (!empty($this->options['input_background_color'])) $bg_color = $this->get_rgb($this->options['input_background_color']);
		echo '
		<style>
			.subscribedownload_signup_form, .subscribedownload_confirmation_info {background-color: '.(empty($this->options['box_color']) ? 'transparent' : $this->options['box_color']).' !important; border-color: '.(empty($this->options['box_border_color']) ? 'transparent' : $this->options['box_border_color']).' !important;'.(empty($this->options['box_font_color']) ? '' : ' color: '.$this->options['box_font_color'].' !important;').' font-size: '.intval($this->options['box_font_size']).'px !important;}
			.subscribedownload_signup_form a, .subscribedownload_confirmation_info a, .subscribedownload_signup_form p, .subscribedownload_confirmation_info p {'.(empty($this->options['box_font_color']) ? '' : ' color: '.$this->options['box_font_color'].';').' !important; font-size: '.intval($this->options['box_font_size']).'px !important;}
			.subscribedownload_signup_form a, .subscribedownload_confirmation_info a {'.(empty($this->options['box_font_color']) ? '' : ' color: '.$this->options['box_font_color'].';').' !important; text-decoration: underline !important;}
			a.subscribedownload-submit, a.subscribedownload-submit:visited {background-color: '.$from_color.' !important; border-color: '.$from_color.' !important; color: '.$this->options['button_font_color'].' !important; font-size: '.intval($this->options['button_font_size']).'px !important; text-decoration: none !important;}
			a.subscribedownload-submit:hover, a.subscribedownload-submit:active {background-color: '.$to_color.' !important; border-color: '.$to_color.' !important; color: '.$this->options['button_font_color'].' !important; font-size: '.intval($this->options['button_font_size']).'px !important; text-decoration: none !important;}
			.subscribedownload_terms, .subscribedownload-input, .subscribedownload-input:hover, .subscribedownload-input:active, .subscribedownload-input:focus{border-color:'.(empty($this->options['input_border_color']) ? 'transparent' : $this->options['input_border_color']).' !important; background-color:'.(empty($this->options['input_background_color']) ? 'transparent' : $this->options['input_background_color']).' !important; background-color:'.(empty($this->options['input_background_color']) ? 'transparent' : 'rgba('.$bg_color['r'].','.$bg_color['g'].','.$bg_color['b'].','.floatval($this->options['input_background_opacity'])).') !important;'.(empty($this->options['input_font_color']) ? '' : ' color: '.$this->options['input_font_color'].' !important;').' font-size: '.intval($this->options['input_font_size']).'px !important;}
		</style>
		<script>
			var subscribedownload_action = "'.admin_url('admin-ajax.php').'";
			var subscribedownload_ga_tracking = "'.$this->options['ga_tracking'].'";
		</script>';
	}
	
	function shortcode_handler($_atts) {
		global $post, $wpdb, $current_user;
		$form = '';
		if ($this->check_options() === true) {
			if (isset($_atts["width"])) $width = intval($_atts["width"]);
			if (isset($_atts['redirect'])) {
				$redirect = $_atts['redirect'];
				if (!preg_match('|^http(s)?://[a-z0-9-]+(.[a-z0-9-]+)*(:[0-9]+)?(/.*)?$|i', $redirect) || strlen($redirect) == 0) return $redirect = '';
			} else $redirect = '';
			if (isset($_atts["narrow"])) $narrow = true;
			else $narrow = false;
			if (isset($width) && $width < 100) unset($width);
			if (isset($_atts["url"])) $url = $_atts["url"];
			else $url = '';
			if (!preg_match('|^http(s)?://[a-z0-9-]+(.[a-z0-9-]+)*(:[0-9]+)?(/.*)?$|i', $url) || strlen($url) == 0) return '';
			if (isset($_atts["title"])) $intro = do_shortcode(trim($_atts["title"]));
			else $intro = do_shortcode(trim($this->options['intro']));
			if (strlen($intro) > 0) $intro = '<div class="subscribedownload_form_row">'.$intro.'</div>';
			
			$suffix = "_".rand(1000, 9999);
			$terms = htmlspecialchars($this->options['terms'], ENT_QUOTES);
			$terms = str_replace("\n", "<br />", $terms);
			$terms = str_replace("\r", "", $terms);
			if (!empty($this->options['terms'])) {
				$terms_id = "t".rand(100,999).rand(100,999).rand(100,999);
				$tac = '
					<div class="subscribedownload_form_row">
						<div id="terms'.$suffix.'" class="subscribedownload_invisible">
							<div class="subscribedownload_terms">'.$terms.'</div>
						</div>
						'.__('By clicking the button below, I agree with the', 'subscribedownload').' <a href="#" onclick="jQuery(\'#terms'.$suffix.'\').slideToggle(300); return false;">'.__('Terms & Conditions', 'subscribedownload').'</a>.
					</div>';
			} else $tac = '';
			$form = '
		<div class="subscribedownload_container'.($narrow ? ' subscribedownload_narrow' : '').'"'.(!empty($width) ? ' style="width: '.$width.'px;"' : '').'>
			<div name="subscribedownload" class="subscribedownload_box" id="subscribedownload'.$suffix.'">
				<div class="subscribedownload_signup_form" id="subscribedownload_signup_form'.$suffix.'">
					'.$intro.'
					<div class="subscribedownload_form_row">
						'.($this->options['disable_name'] == 'on' ? '
						<div class="subscribedownload_form_column subscribedownload_fullwidth subscribedownload_form_right_column">
							<div>
								<input required="required" tabindex="101" class="subscribedownload-input subscribedownload_fullwidth" type="text" id="email'.$suffix.'" placeholder="'.esc_attr($this->options['placeholder_email']).'" value="'.esc_attr($this->options['placeholder_email']).'" onfocus="if (this.value == \''.esc_attr($this->options['placeholder_email']).'\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \''.esc_attr($this->options['placeholder_email']).'\';}" title="'.esc_attr($this->options['placeholder_email']).'" />
							</div>
						</div>' : '
						<div class="subscribedownload_form_column subscribedownload_50">
							<div>
								<input required="required" tabindex="101" class="subscribedownload-input subscribedownload_fullwidth" type="text" id="name'.$suffix.'" placeholder="'.esc_attr($this->options['placeholder_name']).'" value="'.esc_attr($this->options['placeholder_name']).'" onfocus="if (this.value == \''.esc_attr($this->options['placeholder_name']).'\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \''.esc_attr($this->options['placeholder_name']).'\';}" title="'.esc_attr($this->options['placeholder_name']).'" />
							</div>
						</div>
						<div class="subscribedownload_form_column subscribedownload_50 subscribedownload_form_right_column">
							<div>
								<input required="required" tabindex="102" class="subscribedownload-input subscribedownload_fullwidth" type="text" id="email'.$suffix.'" placeholder="'.esc_attr($this->options['placeholder_email']).'" value="'.esc_attr($this->options['placeholder_email']).'" onfocus="if (this.value == \''.esc_attr($this->options['placeholder_email']).'\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \''.esc_attr($this->options['placeholder_email']).'\';}" title="'.esc_attr($this->options['placeholder_email']).'" />
							</div>
						</div>').'
					</div>
					'.$tac.'
					<input type="hidden" id="url'.$suffix.'" value="'.esc_attr($this->encode_url($url)).'" />
					<div>
						<input type="hidden" id="redirect'.$suffix.'" value="'.esc_attr($redirect).'" />
						<a href="#" tabindex="103" class="subscribedownload-submit" id="submit'.$suffix.'" onclick=\'subscribedownload_submit("'.$suffix.'"); return false;\'>'.esc_attr($this->options['button_label']).'</a>
						<div id="loading'.$suffix.'" class="subscribedownload_loading"></div>
					</div>
					<div id="message'.$suffix.'" class="subscribedownload_message"></div>
				</div>
				<div class="subscribedownload_confirmation_container" id="subscribedownload_confirmation_container'.$suffix.'"></div>
			</div>
		</div>';
		}
		return $form;
	}

	function subscribedownload_submit() {
		global $wpdb;
		$email = trim(stripslashes($_POST['subscribedownload_email']));
		$url = trim(stripslashes($_POST['subscribedownload_url']));
		$suffix = trim(stripslashes($_POST['subscribedownload_suffix']));
		$error = '';
		if ($this->options['disable_name'] != 'on') {
			$name = trim(stripslashes($_POST['subscribedownload_name']));
			if ($name == '' || $name == $this->options['placeholder_name']) {
				$error .= '<li>'.__('Your name is required.', 'subscribedownload').'</li>';
			}
		} else $name = '';
		if ($email == '') {
			$error .= '<li>'.__('Your e-mail address is required.', 'subscribedownload').'</li>';
		} else if (!preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,9})$/i", $email)) {
			$error .= '<li>'.__('You have entered an invalid e-mail address.', 'subscribedownload').'</li>';
		} else {
			if ($this->options['email_validation'] == 'on') {
				$email_parts = explode('@',$email);
				if(checkdnsrr($email_parts[1], 'MX')) {
					//if(!fsockopen($email_parts[1], 25, $errno, $errstr, 30)) $error .= '<li>'.__('You have entered an invalid e-mail address.', 'subscribedownload').'</li>';
				} else $error .= '<li>'.__('You have entered an invalid e-mail address.', 'subscribedownload').'</li>';
			}
		}
		$url = $this->decode_url($url);
		if (!preg_match('|^http(s)?://[a-z0-9-]+(.[a-z0-9-]+)*(:[0-9]+)?(/.*)?$|i', $url) || strlen($url) == 0) {
			$error .= '<li>'.__('Download URL was not found.', 'subscribedownload').'</li>';
		}
		if ($error != '') {
			echo '<div class="subscribedownload_error_message">'.__('Attention! Please correct the errors below and try again.', 'subscribedownload');
			echo '<ul class="subscribedownload_error_messages">'.$error.'</ul>';
			echo '</div>';
		} else {
			$secret_key = $this->random_string(24);
			$tmp = $wpdb->get_row("SELECT COUNT(*) AS total FROM ".$wpdb->prefix."sad_users WHERE deleted = '0' AND email = '".esc_sql($email)."' AND url = '".esc_sql($url)."'", ARRAY_A);
			if ($tmp["total"] > 0) {
				$sql = "UPDATE ".$wpdb->prefix."sad_users SET
					name = '".esc_sql($name)."',
					url = '".esc_sql($url)."',
					secret_key = '".esc_sql($secret_key)."',
					registered = '".time()."'
					WHERE deleted = '0' AND email = '".esc_sql($email)."'";
				$wpdb->query($sql);
			} else {
				$sql = "INSERT INTO ".$wpdb->prefix."sad_users (
					name, email, url, secret_key, registered, deleted) VALUES (
					'".esc_sql($name)."',
					'".esc_sql($email)."',
					'".esc_sql($url)."',
					'".esc_sql($secret_key)."',
					'".time()."', '0'
				)";
				$wpdb->query($sql);
			}
			if (empty($name)) $name = substr($email, 0, strpos($email, '@'));
			if ($this->options['mailchimp_enable'] == 'on') {
				$list_id = $this->options['mailchimp_list_id'];
				$dc = "us1";
				if (strstr($this->options['mailchimp_api_key'], "-")) {
					list($key, $dc) = explode("-", $this->options['mailchimp_api_key'], 2);
					if (!$dc) $dc = "us1";
				}
				$mailchimp_url = 'http://'.$dc.'.api.mailchimp.com/1.3/?method=listSubscribe&apikey='.$this->options['mailchimp_api_key'].'&id='.$list_id.'&email_address='.urlencode($email).'&'.($this->options['disable_name'] == 'on' ? '' : 'merge_vars[FNAME]='.urlencode($name).'&merge_vars[LNAME]='.urlencode($name).'&merge_vars[NAME]='.urlencode($name).'&').'merge_vars[OPTIN_IP]='.$_SERVER['REMOTE_ADDR'].'&output=php&double_optin='.($this->options['mailchimp_double'] == 'on' ? '1' : '0').'&send_welcome='.($this->options['mailchimp_welcome'] == 'on' ? '1' : '0');

				$ch = curl_init($url);
				curl_setopt($ch, CURLOPT_URL, $mailchimp_url);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ch, CURLOPT_HEADER, 0);
				curl_setopt($ch, CURLOPT_ENCODING, "");
				curl_setopt($ch, CURLOPT_USERAGENT, 'User-Agent: MCAPI/1.3');
				curl_setopt($ch, CURLOPT_TIMEOUT, 30);
				curl_setopt($ch, CURLOPT_FAILONERROR, 1);
				curl_setopt($ch, CURLOPT_AUTOREFERER, 1);
				curl_setopt($ch, CURLOPT_POST, 1);
				curl_setopt($ch, CURLOPT_POSTFIELDS, null);
				$data  = curl_exec( $ch );
				curl_close( $ch );
			}
			if ($this->options['icontact_enable'] == 'on') {
				$this->icontact_addcontact($name, $email);
			}
			if ($this->options['campaignmonitor_enable'] == 'on') {
				$options['EmailAddress'] = $email;
				$options['Name'] = $name;
				$options['Resubscribe'] = 'true';
				$options['RestartSubscriptionBasedAutoresponders'] = 'true';
				$post = json_encode($options);

				$curl = curl_init('http://api.createsend.com/api/v3/subscribers/'.urlencode($this->options['campaignmonitor_list_id']).'.json');
				curl_setopt($curl, CURLOPT_POST, 1);
				curl_setopt($curl, CURLOPT_POSTFIELDS, $post);
				
				$header = array(
					'Content-Type: application/json',
					'Content-Length: '.strlen($post),
					'Authorization: Basic '.base64_encode($this->options['campaignmonitor_api_key'])
					);

				//curl_setopt($curl, CURLOPT_PORT, 443);
				curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
				curl_setopt($curl, CURLOPT_TIMEOUT, 10);
				curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC ) ;
				//curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 1); // verify certificate
				//curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2); // check existence of CN and verify that it matches hostname
				curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
				curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
					
				$response = curl_exec($curl);
				curl_close($curl);
			}
			if ($this->options['getresponse_enable'] == 'on') {
				$request = json_encode(
					array(
						'method' => 'add_contact',
						'params' => array(
							$this->options['getresponse_api_key'],
							array(
								'campaign' => $this->options['getresponse_campaign_id'],
								'action' => 'standard',
								'name' => $name,
								'email' => $email,
								'cycle_day' => 0,
								'ip' => $_SERVER['REMOTE_ADDR']
							)
						),
						'id' => ''
					)
				);

				$curl = curl_init('http://api2.getresponse.com/');
				curl_setopt($curl, CURLOPT_POST, 1);
				curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
							
				$header = array(
					'Content-Type: application/json',
					'Content-Length: '.strlen($request)
				);

				//curl_setopt($curl, CURLOPT_PORT, 443);
				curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
				curl_setopt($curl, CURLOPT_TIMEOUT, 10);
				//curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 1); // verify certificate
				//curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2); // check existence of CN and verify that it matches hostname
				curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
				curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
				curl_setopt($curl, CURLOPT_HEADER, 0);
							
				$response = curl_exec($curl);
				curl_close($curl);
			}
			if ($this->options['aweber_access_secret']) {
				if ($this->options['aweber_enable'] == 'on') {
					$account = null;
					if (!class_exists('AWeberAPI')) {
						require_once(dirname(__FILE__).'/aweber_api/aweber_api.php');
					}
					try {
						$aweber = new AWeberAPI($this->options['aweber_consumer_key'], $this->options['aweber_consumer_secret']);
						$account = $aweber->getAccount($this->options['aweber_access_key'], $this->options['aweber_access_secret']);
						$subscribers = $account->loadFromUrl('/accounts/' . $account->id . '/lists/' . $this->options['aweber_listid'] . '/subscribers');
						$subscribers->create(array(
							'email' => $email,
							'ip_address' => $_SERVER['REMOTE_ADDR'],
							'name' => $name,
							'ad_tracking' => 'Subscribe & Download',
						));
					} catch (Exception $e) {
						$account = null;
					}
				}
			}
			if (function_exists('mymail_subscribe') || function_exists('mymail')) {
				if ($this->options['mymail_enable'] == 'on') {
					if (function_exists('mymail')) {
						$list = mymail('lists')->get($this->options['mymail_listid']);
					} else {
						$list = get_term_by('id', $this->options['mymail_listid'], 'newsletter_lists');
					}
					if (!empty($list)) {
						try {
							if ($this->options['mymail_double'] == "on") $double = true;
							else $double = false;
							if (function_exists('mymail')) {
								$entry = array(
									'firstname' => $name,
									'email' => $email,
									'status' => $double ? 0 : 1,
									'ip' => $_SERVER['REMOTE_ADDR'],
									'signup_ip' => $_SERVER['REMOTE_ADDR'],
									'referer' => $_SERVER['HTTP_REFERER'],
									'signup' =>time()
								);
								$subscriber_id = mymail('subscribers')->add($entry, true);
								if (is_wp_error( $subscriber_id )) return;
								$result = mymail('subscribers')->assign_lists($subscriber_id, array($list->ID));
							} else {
								$result = mymail_subscribe($email, array('firstname' => $name), array($term->slug), $double);
							}
						} catch (Exception $e) {
						}
					}
				}
			}
			if ($this->options['madmimi_enable'] == 'on') {
				$request = http_build_query(array(
					'email' => $email,
					'first_name' => $name,
					'last_name' => '',
					'username' => $this->options['madmimi_login'],
					'api_key' => $this->options['madmimi_api_key']
				));

				$curl = curl_init('http://api.madmimi.com/audience_lists/'.$this->options['madmimi_list_id'].'/add');
				curl_setopt($curl, CURLOPT_POST, 1);
				curl_setopt($curl, CURLOPT_POSTFIELDS, $request);

				curl_setopt($curl, CURLOPT_TIMEOUT, 20);
				curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
				curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
				curl_setopt($curl, CURLOPT_HEADER, 0);
									
				$response = curl_exec($curl);
				curl_close($curl);
			}
			if ($this->options['mail_enable'] == 'on') {
				$tags = array("{download_link}", "{name}", "{e-mail}", "{email}", "{ip}", "{source}", "\n", "\r");
				$vals = array(get_bloginfo('url').'/?sad-key='.$secret_key, $name, $email, $email, $_SERVER['REMOTE_ADDR'], $_SERVER['HTTP_REFERER'], "<br />", "");
				$body = str_replace($tags, $vals, $this->options['mail_message']);
				$mail_headers = "Content-Type: text/html; charset=utf-8\r\n";
				$from_set = false;
				if (!empty($email)) {
					$mail_headers .= "Reply-To: ".(empty($name) ? esc_html($email) : esc_html($name))." <".esc_html($email).">\r\n";
					if ($this->options['mail_from'] == 'on') {
						$from_set = true;
						$mail_headers .= "From: ".(empty($name) ? esc_html($email) : esc_html($name))." <".esc_html($email).">\r\n";
					}
				}
				if (!$from_set) {
					$mail_headers .= "From: ".(empty($this->options['from_name']) ? esc_html($this->options['from_email']) : esc_html($this->options['from_name']))." <".esc_html($this->options['from_email']).">\r\n";
				}
				$mail_emails = explode(',', $this->options['mail_email']);
				foreach ($mail_emails as $mail_email) {
					$mail_email = trim($mail_email);
					if (!empty($mail_email)) {
						if (preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,9})$/i", $mail_email)) {
							wp_mail($mail_email, $this->options['mail_subject'], $body, $mail_headers);					
						}
					}
				}
			}
			$tags = array("{download_link}", "{name}", "{e-mail}", "{email}", "\n", "\r");
			$vals = array(get_bloginfo('url').'/?sad-key='.$secret_key, $name, $email, $email, "<br />", "");
			$body = str_replace($tags, $vals, $this->options['success_email_body']);
			$mail_headers = "Content-Type: text/html; charset=utf-8\r\n";
			$mail_headers .= "From: ".$this->options['from_name']." <".$this->options['from_email'].">\r\n";
			$mail_headers .= "X-Mailer: PHP/".phpversion()."\r\n";
			wp_mail($email, $this->options['success_email_subject'], $body, $mail_headers);
			echo '
<div class="subscribedownload_confirmation_info" style="text-align: center;">
	'.__('Download link was sent to', 'subscribedownload').' <strong>'.htmlspecialchars($email, ENT_QUOTES).'.</strong>
</div>';		
		}
		exit;
	}

	function get_rgb($_color) {
		if (strlen($_color) != 7 && strlen($_color) != 4) return false;
		$color = preg_replace('/[^#a-fA-F0-9]/', '', $_color);
		if (strlen($color) != strlen($_color)) return false;
		if (strlen($color) == 7) list($r, $g, $b) = array($color[1].$color[2], $color[3].$color[4], $color[5].$color[6]);
		else list($r, $g, $b) = array($color[1].$color[1], $color[2].$color[2], $color[3].$color[3]);
		return array("r" => hexdec($r), "g" => hexdec($g), "b" => hexdec($b));
	}
	
	function madmimi_getlists($_login, $_key) {
		$curl = curl_init('http://api.madmimi.com/audience_lists/lists.json?'.http_build_query(array('username' => $_login, 'api_key' => $_key)));
		curl_setopt($curl, CURLOPT_POST, 0);
		curl_setopt($curl, CURLOPT_TIMEOUT, 10);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
		curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
		curl_setopt($curl, CURLOPT_HEADER, 0);
														
		$response = curl_exec($curl);
											
		if (curl_error($curl)) return array();
		$httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
		if ($httpCode != '200') return array();
		curl_close($curl);
											
		$result = json_decode($response, true);
		if(!$result) return array();
		$lists = array();
		foreach ($result as $key => $value) {
			$lists[$value['id']] = $value['name'];
		}
		return $lists;
	}

	function icontact_getlists() {
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/', null, 'accounts');
		if (!empty($data['errors'])) return array();
		$account = $data['response'][0];
		if (empty($account) || intval($account->enabled != 1)) return;
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/'.$account->accountId.'/c/', null, 'clientfolders');
		if (!empty($data['errors'])) return array();
		$client = $data['response'][0];
		if (empty($client)) return array();
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/'.$account->accountId.'/c/'.$client->clientFolderId.'/lists', array(), 'lists');
		if (!empty($data['errors'])) return array();
		if (!is_array($data['response'])) return array();
		$lists = array();
		foreach ($data['response'] as $list) {
			$lists[$list->listId] = $list->name;
		}
		return $lists;
	}

	function icontact_addcontact($name, $email) {
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/', null, 'accounts');
		if (!empty($data['errors'])) return;
		$account = $data['response'][0];
		if (empty($account) || intval($account->enabled != 1)) return;
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/'.$account->accountId.'/c/', null, 'clientfolders');
		if (!empty($data['errors'])) return;
		$client = $data['response'][0];
		if (empty($client)) return;
		$contact['email'] = $email;
		$contact['firstName'] = $name;
		$contact['status'] = 'normal';
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/'.$account->accountId.'/c/'.$client->clientFolderId.'/contacts', array($contact), 'contacts');
		if (!empty($data['errors'])) return;
		$contact = $data['response'][0];
		if (empty($contact)) return;
		$subscriber['contactId'] = $contact->contactId;
		$subscriber['listId'] = $this->options['icontact_listid'];
		$subscriber['status'] = 'normal';
		$data = $this->icontact_makecall($this->options['icontact_appid'], $this->options['icontact_apiusername'], $this->options['icontact_apipassword'], '/a/'.$account->accountId.'/c/'.$client->clientFolderId.'/subscriptions', array($subscriber), 'subscriptions');
	}

	function icontact_makecall($appid, $apiusername, $apipassword, $resource, $postdata = null, $returnkey = null) {
		$return = array();
		$url = "https://app.icontact.com/icp".$resource;
		$headers = array(
			'Except:', 
			'Accept:  application/json', 
			'Content-type:  application/json', 
			'Api-Version:  2.2',
			'Api-AppId:  '.$appid, 
			'Api-Username:  '.$apiusername, 
			'Api-Password:  '.$apipassword
		);
		$handle = curl_init();
		curl_setopt($handle, CURLOPT_HTTPHEADER, $headers);
		curl_setopt($handle, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($handle, CURLOPT_SSL_VERIFYPEER, false);
		if (!empty($postdata)) {
			curl_setopt($handle, CURLOPT_POST, true);
			curl_setopt($handle, CURLOPT_POSTFIELDS, json_encode($postdata));
		}
		curl_setopt($handle, CURLOPT_URL, $url);
		if (!$response_json = curl_exec($handle)) {
			$return['errors'][] = __('Unable to execute the cURL handle.', 'subscribedownload');
		}
		if (!$response = json_decode($response_json)) {
			$return['errors'][] = __('The iContact API did not return valid JSON.', 'subscribedownload');
		}
		curl_close($handle);
		if (!empty($response->errors)) {
			foreach ($response->errors as $error) {
				$return['errors'][] = $error;
			}
		}
		if (!empty($return['errors'])) return $return;
		if (empty($returnkey)) {
			$return['response'] = $response;
		} else {
			$return['response'] = $response->$returnkey;
		}
		return $return;
	}

	function encode_url($_url) {
		return base64_encode($_url);
	}

	function decode_url($_url) {
		return base64_decode($_url);
	}

	function random_string($_length = 16) {
		$symbols = '123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$string = "";
		for ($i=0; $i<$_length; $i++) {
			$string .= $symbols[rand(0, strlen($symbols)-1)];
		}
		return $string;
	}

	function page_switcher ($_urlbase, $_currentpage, $_totalpages) {
		$pageswitcher = "";
		if ($_totalpages > 1) {
			$pageswitcher = '<div class="tablenav bottom"><div class="tablenav-pages">'.__('Pages:', 'subscribedownload').' <span class="pagiation-links">';
			if (strpos($_urlbase,"?") !== false) $_urlbase .= "&amp;";
			else $_urlbase .= "?";
			if ($_currentpage == 1) $pageswitcher .= "<a class='page disabled'>1</a> ";
			else $pageswitcher .= " <a class='page' href='".$_urlbase."p=1'>1</a> ";

			$start = max($_currentpage-3, 2);
			$end = min(max($_currentpage+3,$start+6), $_totalpages-1);
			$start = max(min($start,$end-6), 2);
			if ($start > 2) $pageswitcher .= " <b>...</b> ";
			for ($i=$start; $i<=$end; $i++) {
				if ($_currentpage == $i) $pageswitcher .= " <a class='page disabled'>".$i."</a> ";
				else $pageswitcher .= " <a class='page' href='".$_urlbase."p=".$i."'>".$i."</a> ";
			}
			if ($end < $_totalpages-1) $pageswitcher .= " <b>...</b> ";

			if ($_currentpage == $_totalpages) $pageswitcher .= " <a class='page disabled'>".$_totalpages."</a> ";
			else $pageswitcher .= " <a class='page' href='".$_urlbase."p=".$_totalpages."'>".$_totalpages."</a> ";
			$pageswitcher .= "</span></div></div>";
		}
		return $pageswitcher;
	}
}
$subscribedownload = new subscribedownload_class();
?>